<template>
	<view :style="boxStyle() || ''" class="imgList">
		<view  v-if="imgArr.length === 1">
			<image @click="showImg(0)" :style="imgStyle() || ''" mode="widthFix" :src="imgArr[0]" />
		</view>
		<view class="more" v-else>
			<image @click="showImg(index)" mode="aspectFill" :style="imgStyle(index) || ''" v-for="(item, index) in imgArr" :key="index" :src="item" />
		</view>
		<view style="clear: both;"></view>
	</view>
</template>

<script lang="ts">
	import {
		Vue,
		Component,
		Prop,
		Watch
	} from "vue-property-decorator";
	
	@Component({})
	export default class JiugonggeImg extends Vue {
	
		private imgArr: Array<string> = []
		private trueArr: Array<number> = [2, 5, 8]

		@Prop({
			// 父组件传递给子组件的数据类型
			type: Object,

			// 是否必填
			required: false,

			// 默认值， 如果传入的是 Object，则要 default: ()=>({}) 参数为函数
			default: () => ({
				title: {
					text: ''
				}
			})
		}) config!: jiugonggeImg.config;

		@Prop({
				// 父组件传递给子组件的数据类型
				type: Object,

				// 是否必填
				required: false,

				// 默认值， 如果传入的是 Object，则要 default: ()=>({}) 参数为函数
				default: () => ({
					title: {
						text: ''
					}
				})
			}) imageData?: any;

		created() {
			this.getData()	
		}

	  
		getData() {
			let imageData = this.imageData || []
			if(!this.config.prop) return imageData
			let arr: Array<any> = []
			for(let i = 1; i <= 9; i++){
				let temp = `${this.config.prop}${i}`
				let val = imageData[temp]
				if(val) arr.push(val)
			}
			this.imgArr = arr
		}

		showImg(index: number) {
			let url = this.config.prop ? this.imageData[`${this.config.prop}${index + 1}`] : this.imgArr[index]
			uni.previewImage({
				// 当前显示图片的http链接
				current: url, 
				 // 需要预览的图片http链接列表
				urls: this.imgArr
			})
		}

		boxStyle() {
			let arr = [
				`width: ${this.config.width}vw`,
				`margin-left:${this.config.left}vw`
			]
			return arr.join(';')
		}

		imgStyle(index?: number) {
			let arr = [`margin-bottom:${this.config.margin}vw`]
			let width = (this.config.width  || 100) - 2 * (this.config.margin || 1)
			arr.push(`border-radius: 2vw`)
			if(index === undefined) {
				return `width: ${width * 0.75}vw;`
			}
			let oneW = width / 3
			arr.push(`width: ${oneW}vw`)
			arr.push(`height: ${oneW}vw`)
			if( this.trueArr.includes((index || 0) + 1)) {
				arr.push(`margin-left:${this.config.margin}vw`)
				arr.push(`margin-right:${this.config.margin}vw`)
			}
			return arr.join(';')
		}
	}
</script>

<style lang="scss" scoped>
.imgList{
	image {
		float: left;
	}
}
</style>
